/*
 * mutex.hpp
 *
 *  Created on: 26 . 2022 .
 *      Author: sychev
 */

#ifndef SRC_MUTEX_MUTEX_HPP_
#define SRC_MUTEX_MUTEX_HPP_

#include <kernel/freertos/FreeRTOS-Kernel/include/FreeRTOS.h>
#include <kernel/freertos/FreeRTOS-Kernel/include/semphr.h>

namespace free_rtos {

/**
 * @brief ++     ti rtos
 * 
 */
class Mutex {
public:
    Mutex();

    /**
     * wait -    ,  
     * portMAX_DELAY -  , 0 -  
     *  pdTRUE    
     */
    BaseType_t lock(TickType_t wait = portMAX_DELAY);

    void unlock(void);

    ~Mutex();

private:
    SemaphoreHandle_t  handle_;
};

/**
 * @brief   LockGuard
 * 
 */
class LockGuard {
public:
    LockGuard(Mutex& mutex);

    ~LockGuard();

private:
   Mutex& mutex_;
};

}



#endif /* SRC_MUTEX_MUTEX_HPP_ */
